#ifndef _CD2ISO_EXCEPTION_H
#define _CD2ISO_EXCEPTION_H

#include <exception>
#include <string>

#define THROW_EX_IF(cond, reason) if(cond){throw Cd2isoException(reason, __FILE__, __LINE__);}
#define THROW_EX(reason) throw Cd2isoException(reason, __FILE__, __LINE__);
#define THROW_EX_LOG(reason, loglevel) throw Cd2isoException(reason, __FILE__, __LINE__, loglevel);

class Cd2isoException : public std::exception
{
    public:
        Cd2isoException(const char* reason, const char* file = "Unknown file", const int line = -1, const int loglevel = -1) throw();
        ~Cd2isoException() throw();
        virtual const char* what() throw();
    private:
        const char* _reason;
        const char* _file;
        int _line;
        int _loglevel;
        std::string* _message;
};

#endif
