/******************************************************************
 * Class that handles the creation of image files (eg .iso)       *
 * Note: this is tightly coupled with other parts of the plugin.  *
 * Depends on: DeviceReader.h progressview.h util.h               *
 ******************************************************************/

#ifndef IMGCREATOR_H
#define IMGCREATOR_H

#include <windows.h>
#include <string>
#include <fstream>

class ImgCreator {
public:
	ImgCreator();
	bool createImg(std::string fileNameIn, std::string fileNameOut);
	std::string getError();
private:
	void updateProgress(long long bytesWritten);
	long long mTotalBytes;
	std::ofstream mOutFile;
	std::string mError;
	double next_progress;
	bool mSuccessful;
};

#endif

