/*
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <windows.h>
#include <string>
#include "Logger.hpp"
#include "util.h"

using namespace std;

string get_lasterror()
{
    LPVOID lpMsgBuf;
    DWORD dw = GetLastError();
    
    FormatMessage(
        FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
        NULL,
        dw,
        MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
        (LPTSTR) &lpMsgBuf,
        0, NULL );
    
    string error = string("LastError = ") + str(dw) + " " + (char*)lpMsgBuf;
    LocalFree(lpMsgBuf);
    
    return error;
}

long long getDiskSize(string driveLetter)
{
	ULARGE_INTEGER TotalBytes;
	string diskPath = driveLetter + ":\\";
	LOG_DEBUG("diskPath: '"+diskPath+"'");
	LOG_DEBUG("Calling GetDiskFreeSpaceEx...");
	BOOL result = GetDiskFreeSpaceEx(diskPath.c_str(), NULL, &TotalBytes, NULL);
	if(result == 0) {
	    LOG_ERROR("GetDiskFreeSpaceEx failed! "+get_lasterror());
	    return 0;
	}
	return TotalBytes.QuadPart;
}

